~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/extract-vmlinux

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/extract-vmlinux (Version linux-6.12-rc7) and /scripts/extract-vmlinux (Version linux-5.2.21)


  1 #!/bin/sh                                           1 #!/bin/sh
  2 # SPDX-License-Identifier: GPL-2.0-only             2 # SPDX-License-Identifier: GPL-2.0-only
  3 # --------------------------------------------      3 # ----------------------------------------------------------------------
  4 # extract-vmlinux - Extract uncompressed vmlin      4 # extract-vmlinux - Extract uncompressed vmlinux from a kernel image
  5 #                                                   5 #
  6 # Inspired from extract-ikconfig                    6 # Inspired from extract-ikconfig
  7 # (c) 2009,2010 Dick Streefland <dick@streeflan      7 # (c) 2009,2010 Dick Streefland <dick@streefland.net>
  8 #                                                   8 #
  9 # (c) 2011      Corentin Chary <corentin.chary@      9 # (c) 2011      Corentin Chary <corentin.chary@gmail.com>
 10 #                                                  10 #
 11 # --------------------------------------------     11 # ----------------------------------------------------------------------
 12                                                    12 
 13 check_vmlinux()                                    13 check_vmlinux()
 14 {                                                  14 {
 15         # Use readelf to check if it's a valid     15         # Use readelf to check if it's a valid ELF
 16         # TODO: find a better to way to check      16         # TODO: find a better to way to check that it's really vmlinux
 17         #       and not just an elf                17         #       and not just an elf
 18         readelf -h $1 > /dev/null 2>&1 || retu     18         readelf -h $1 > /dev/null 2>&1 || return 1
 19                                                    19 
 20         cat $1                                     20         cat $1
 21         exit 0                                     21         exit 0
 22 }                                                  22 }
 23                                                    23 
 24 try_decompress()                                   24 try_decompress()
 25 {                                                  25 {
 26         # The obscure use of the "tr" filter i     26         # The obscure use of the "tr" filter is to work around older versions of
 27         # "grep" that report the byte offset o     27         # "grep" that report the byte offset of the line instead of the pattern.
 28                                                    28 
 29         # Try to find the header ($1) and deco     29         # Try to find the header ($1) and decompress from here
 30         for     pos in `tr "$1\n$2" "\n$2=" <      30         for     pos in `tr "$1\n$2" "\n$2=" < "$img" | grep -abo "^$2"`
 31         do                                         31         do
 32                 pos=${pos%%:*}                     32                 pos=${pos%%:*}
 33                 tail -c+$pos "$img" | $3 > $tm     33                 tail -c+$pos "$img" | $3 > $tmp 2> /dev/null
 34                 check_vmlinux $tmp                 34                 check_vmlinux $tmp
 35         done                                       35         done
 36 }                                                  36 }
 37                                                    37 
 38 # Check invocation:                                38 # Check invocation:
 39 me=${0##*/}                                        39 me=${0##*/}
 40 img=$1                                             40 img=$1
 41 if      [ $# -ne 1 -o ! -s "$img" ]                41 if      [ $# -ne 1 -o ! -s "$img" ]
 42 then                                               42 then
 43         echo "Usage: $me <kernel-image>" >&2       43         echo "Usage: $me <kernel-image>" >&2
 44         exit 2                                     44         exit 2
 45 fi                                                 45 fi
 46                                                    46 
 47 # Prepare temp files:                              47 # Prepare temp files:
 48 tmp=$(mktemp /tmp/vmlinux-XXX)                     48 tmp=$(mktemp /tmp/vmlinux-XXX)
 49 trap "rm -f $tmp" 0                                49 trap "rm -f $tmp" 0
 50                                                    50 
 51 # That didn't work, so retry after decompressi     51 # That didn't work, so retry after decompression.
 52 try_decompress '\037\213\010' xy    gunzip         52 try_decompress '\037\213\010' xy    gunzip
 53 try_decompress '\3757zXZ\000' abcde unxz           53 try_decompress '\3757zXZ\000' abcde unxz
 54 try_decompress 'BZh'          xy    bunzip2        54 try_decompress 'BZh'          xy    bunzip2
 55 try_decompress '\135\0\0\0'   xxx   unlzma         55 try_decompress '\135\0\0\0'   xxx   unlzma
 56 try_decompress '\211\114\132' xy    'lzop -d'      56 try_decompress '\211\114\132' xy    'lzop -d'
 57 try_decompress '\002!L\030'   xxx   'lz4 -d'       57 try_decompress '\002!L\030'   xxx   'lz4 -d'
 58 try_decompress '(\265/\375'   xxx   unzstd         58 try_decompress '(\265/\375'   xxx   unzstd
 59                                                    59 
 60 # Finally check for uncompressed images or obj     60 # Finally check for uncompressed images or objects:
 61 check_vmlinux $img                                 61 check_vmlinux $img
 62                                                    62 
 63 # Bail out:                                        63 # Bail out:
 64 echo "$me: Cannot find vmlinux." >&2               64 echo "$me: Cannot find vmlinux." >&2
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php